<?php
class GcsClientLogicException extends Exception {
    
}

class GcsClientLogic {
	
   	/**
   	 * Timeout da conexao com o servidor remoto
   	 * @var int
   	 */
   	const REMOTE_REQUEST_TIMEOUT_SECONDS = 0;
    
    const SERVICO_REALIZAR_REMOTO = 'CreateSvnTag';
    
    const SERVICO_ATUALIZAR_REMOTO = 'UpdateEnvironment';
    
    const SERVICO_CONCLUIR_REMOTO = 'CommitFiles';
    
    const CAMINHO_DIR_ATIVIDADES_LOCAL = 'C:\\workfolder\\tempfiles\\tags\\atividades\\';
    
    const CAMINHO_PROJETO_GCS = '/products/v_%s/source/gcs/index.php';
    
    
    /**
     * Retorna a uri do projeto gcs na maquina local.
     * @return type 
     */
    public static function retornaUrlGcsLocal() {
        $codOperador = Ambiente::getCdOperador();
        $objOperador = Operador::consultaOperador($codOperador);
        $nmAcessoOperador = $objOperador->getNmacesso();
		$ipOperador = $objOperador->getNroperrede();
		if (empty($ipOperador) === true) {
			throw new Exception(tk_get_message_by_name('msg_apr_ip_requerido'));
		}
		
		if (empty($nmAcessoOperador) === true) {
			throw new Exception(tk_get_message_by_name('msg_apr_nome_acesso_requerido'));
		}
				
    	$caminhoGcs = self::CAMINHO_PROJETO_GCS;
        $versaoProduto = GepApropriacaoAtividadeLogic::retornaVersaoCorrenteProdutos();
        $caminhoGcs = sprintf($caminhoGcs, $versaoProduto);
        $urlGcs  = "http://{$ipOperador}:9090/{$nmAcessoOperador}{$caminhoGcs}";
        
        return $urlGcs;
    }
    
    /**
	 * Realiza uma requisicao para uma url remota.
	 * 
	 * @param string $url
	 * @param string $curl_options
	 * 
	 * @throws Exception
	 * 
	 * @return mixed
	 */
	public static function remoteRequest($url, $curlOptions = array()) {
        list($url, $params) = explode('?', $url);
        set_time_limit(0);
		$ch = curl_init($url);
		$preDefined = array(
			CURLOPT_FAILONERROR => true,
			CURLOPT_RETURNTRANSFER => true,
			CURLOPT_CONNECTTIMEOUT => self::REMOTE_REQUEST_TIMEOUT_SECONDS,
            CURLOPT_POST => true,
            CURLOPT_POSTFIELDS => $params 
		);

		foreach ($preDefined as $opt => $value) {
			$value = isset($curlOptions[$opt]) === true ? $curlOptions[$opt] : $value;
			curl_setopt($ch, $opt, $value);
		}

		// request
		$data = curl_exec($ch);
		$error = curl_error($ch);
		curl_close($ch);
		if (empty($error) === true) {
			return $data;
		} 
        
        $errorMessage = tk_get_message_by_name('msg_apr_erro_conexao_gcs', array($error, $url));
        throw new GcsClientLogicException($errorMessage);
    }
}